"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLutAddressesForCandyMachine = exports.createLutForCandyMachine = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const umi_1 = require("@metaplex-foundation/umi");
const mpl_core_1 = require("@metaplex-foundation/mpl-core");
const generated_1 = require("./generated");
const hooked_1 = require("./hooked");
const createLutForCandyMachine = async (context, recentSlot, candyMachine, collectionUpdateAuthority, lutAuthority) => {
    const addresses = await (0, exports.getLutAddressesForCandyMachine)(context, candyMachine, collectionUpdateAuthority);
    return (0, mpl_toolbox_1.createLut)(context, {
        recentSlot,
        addresses,
        authority: lutAuthority,
    });
};
exports.createLutForCandyMachine = createLutForCandyMachine;
const getLutAddressesForCandyMachine = async (context, candyMachine, collectionUpdateAuthority) => {
    const candyMachineAccount = await (0, generated_1.fetchCandyMachine)(context, candyMachine);
    const { mintAuthority, collectionMint } = candyMachineAccount;
    collectionUpdateAuthority ?? (collectionUpdateAuthority = context.identity.publicKey);
    return (0, umi_1.uniquePublicKeys)([
        candyMachine,
        mintAuthority,
        collectionMint,
        collectionUpdateAuthority,
        (0, hooked_1.findCandyMachineAuthorityPda)(context, { candyMachine })[0],
        (0, mpl_toolbox_1.getSysvar)('instructions'),
        (0, mpl_toolbox_1.getSysvar)('slotHashes'),
        (0, mpl_core_1.getMplCoreProgramId)(context),
        (0, mpl_toolbox_1.getSplTokenProgramId)(context),
        (0, mpl_toolbox_1.getSplAssociatedTokenProgramId)(context),
        (0, mpl_token_metadata_1.getMplTokenMetadataProgramId)(context),
        (0, generated_1.getMplCoreCandyMachineCoreProgramId)(context),
    ]);
};
exports.getLutAddressesForCandyMachine = getLutAddressesForCandyMachine;
//# sourceMappingURL=createLutForCandyMachine.js.map