import { Signer } from '@metaplex-foundation/umi';
import { Allocation, AllocationArgs } from '../generated';
import { GuardManifest } from '../guards';
/**
 * Guard to specify the maximum number of mints in a guard set.
 *
 */
export declare const allocationGuardManifest: GuardManifest<AllocationArgs, Allocation, AllocationMintArgs, AllocationRouteArgs>;
export declare type AllocationMintArgs = Omit<AllocationArgs, 'limit'>;
/**
 * The allocation guard arguments that should be provided
 * when accessing the guard's special "route" instruction.
 */
export declare type AllocationRouteArgs = Omit<AllocationArgs, 'limit'> & {
    /** The authority of the Candy Guard as a Signer. */
    candyGuardAuthority: Signer;
};
