import { MintLimit, MintLimitArgs } from '../generated';
import { GuardManifest } from '../guards';
/**
 * The mintLimit guard allows to specify a limit on the
 * number of mints for each individual wallet.
 *
 * The limit is set per wallet, per candy machine and per
 * identified (provided in the settings) to allow multiple
 * mint limits within a Candy Machine. This is particularly
 * useful when using groups of guards and we want each of them
 * to have a different mint limit.
 */
export declare const mintLimitGuardManifest: GuardManifest<MintLimitArgs, MintLimit, MintLimitMintArgs>;
export declare type MintLimitMintArgs = Omit<MintLimitArgs, 'limit'>;
