"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.solFixedFeeGuardManifest = void 0;
const generated_1 = require("../generated");
const guards_1 = require("../guards");
/**
 * The solFixedFee guard is used to charge an
 * amount in SOL for the minted NFT as a fee.
 */
exports.solFixedFeeGuardManifest = {
    name: 'solFixedFee',
    serializer: generated_1.getSolFixedFeeSerializer,
    mintParser: (context, mintContext, args) => ({
        data: new Uint8Array(),
        remainingAccounts: [{ publicKey: args.destination, isWritable: true }],
    }),
    routeParser: guards_1.noopParser,
};
//# sourceMappingURL=solFixedFee.js.map