import { Token2022Payment, Token2022PaymentArgs } from '../generated';
import { GuardManifest } from '../guards';
/**
 * The token2022Payment guard allows minting by charging the
 * payer a specific amount of tokens from a certain mint acount
 * using Token2022. The tokens will be transfered to a predefined
 * destination.
 *
 * This guard alone does not limit how many times a holder
 * can mint. A holder can mint as many times as they have
 * the required amount of tokens to pay with.
 */
export declare const token2022PaymentGuardManifest: GuardManifest<Token2022PaymentArgs, Token2022Payment, Token2022PaymentMintArgs>;
export declare type Token2022PaymentMintArgs = Omit<Token2022PaymentArgs, 'amount'>;
