import { TokenGate, TokenGateArgs } from '../generated';
import { GuardManifest } from '../guards';
/**
 * The tokenGate guard restricts minting to token holders
 * of a specified mint account. The `amount` determines
 * how many tokens are required.
 *
 * This guard alone does not limit how many times a holder
 * can mint. A holder can mint as many times as they have
 * the required amount of tokens to pay with.
 */
export declare const tokenGateGuardManifest: GuardManifest<TokenGateArgs, TokenGate, TokenGateMintArgs>;
export declare type TokenGateMintArgs = Omit<TokenGateArgs, 'amount'>;
