import { TokenPayment, TokenPaymentArgs } from '../generated';
import { GuardManifest } from '../guards';
/**
 * The tokenPayment guard allows minting by charging the
 * payer a specific amount of tokens from a certain mint acount.
 * The tokens will be transfered to a predefined destination.
 *
 * This guard alone does not limit how many times a holder
 * can mint. A holder can mint as many times as they have
 * the required amount of tokens to pay with.
 */
export declare const tokenPaymentGuardManifest: GuardManifest<TokenPaymentArgs, TokenPayment, TokenPaymentMintArgs>;
export declare type TokenPaymentMintArgs = Omit<TokenPaymentArgs, 'amount'>;
