import { Serializer } from '@metaplex-foundation/umi/serializers';
import { CandyGuardProgram, GuardRepository } from './guardRepository';
import { GuardSet, GuardSetArgs } from './guardSet';
/**
 * A group represent a specific set of guards. When groups are used, transactions
 * must specify which group should be used during validation.
 */
export declare type GuardGroup<D extends GuardSet> = {
    label: string;
    guards: D;
};
export declare type GuardGroupArgs<DA extends GuardSetArgs> = {
    label: string;
    guards: Partial<DA>;
};
export declare function getGuardGroupSerializer<DA extends GuardSetArgs, D extends DA & GuardSet>(context: {
    coreGuards: GuardRepository;
}, program: CandyGuardProgram): Serializer<GuardGroupArgs<DA>, GuardGroup<D>>;
