"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mintV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const mintV2_1 = require("./generated/instructions/mintV2");
const guards_1 = require("./guards");
const hooked_1 = require("./hooked");
function mintV2(context, input) {
    const { mintArgs = {}, group = (0, umi_1.none)(), ...rest } = input;
    // Parsing mint data.
    const program = context.programs.get('mplCoreCandyGuard');
    const candyMachine = (0, umi_1.publicKey)(input.candyMachine, false);
    const mintContext = {
        minter: input.minter ?? context.identity,
        payer: input.payer ?? context.payer,
        asset: (0, umi_1.publicKey)(input.asset, false),
        candyMachine,
        candyGuard: (0, umi_1.publicKey)(input.candyGuard ?? (0, hooked_1.findCandyGuardPda)(context, { base: candyMachine }), false),
    };
    const { data, remainingAccounts } = (0, guards_1.parseMintArgs)(context, program, mintContext, mintArgs);
    const ix = (0, mintV2_1.mintV2)(context, {
        ...rest,
        mintArgs: data,
        group,
    }).items[0];
    const [keys, signers] = (0, guards_1.parseGuardRemainingAccounts)(remainingAccounts);
    ix.instruction.keys.push(...keys);
    ix.signers.push(...signers);
    // TODO fix size calculation
    // ix.bytesCreatedOnChain =
    //   METADATA_SIZE + MASTER_EDITION_SIZE + 2 * ACCOUNT_HEADER_SIZE;
    // if (isSigner(input.asset)) {
    //   ix.bytesCreatedOnChain +=
    //     getMintSize() + getTokenSize() + 2 * ACCOUNT_HEADER_SIZE;
    // }
    return (0, umi_1.transactionBuilder)([ix]);
}
exports.mintV2 = mintV2;
//# sourceMappingURL=mintV2.js.map