"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.route = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const route_1 = require("./generated/instructions/route");
const guards_1 = require("./guards");
const hooked_1 = require("./hooked");
function route(context, input) {
    const { routeArgs = {}, group = (0, umi_1.none)(), ...rest } = input;
    const program = context.programs.get('mplCoreCandyGuard');
    const candyMachine = (0, umi_1.publicKey)(input.candyMachine, false);
    const routeContext = {
        payer: input.payer ?? context.payer,
        candyMachine,
        candyGuard: (0, umi_1.publicKey)(input.candyGuard ?? (0, hooked_1.findCandyGuardPda)(context, { base: candyMachine }), false),
    };
    const { data, remainingAccounts, guardIndex } = (0, guards_1.parseRouteArgs)(context, program, routeContext, input.guard, input.routeArgs);
    const ix = (0, route_1.route)(context, { ...rest, guard: guardIndex, data, group })
        .items[0];
    const [keys, signers] = (0, guards_1.parseGuardRemainingAccounts)(remainingAccounts);
    ix.instruction.keys.push(...keys);
    ix.signers.push(...signers);
    return (0, umi_1.transactionBuilder)([ix]);
}
exports.route = route;
//# sourceMappingURL=route.js.map